## libmmmulti 0.1

=== CMakeLists.txt ===
# Specify the minimum version for CMake

cmake_minimum_required(VERSION 3.1)

# Project's name
project(mmmulti)
# We build using c++14
set(CMAKE_CXX_STANDARD 14)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# Use all standard-compliant optimizations
set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3 -mcx16 -g")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -mcx16 -g")

# Set the output folder where your program will be created
set(CMAKE_BINARY_DIR ${CMAKE_SOURCE_DIR}/bin)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
set(LIBRARY_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/lib)

# The following folder will be included
include_directories("${PROJECT_SOURCE_DIR}")

# Add external projects
include(${CMAKE_ROOT}/Modules/ExternalProject.cmake)

# TODO: We're using INSTALL_DIR very wrong. We *should* be actually installing
# the external projects into their prefixes and working with the installed
# files. Instead we're building but not installing them and trying to work with
# the non-installed build trees.
# 
# Hence the blanked out INSTALL_COMMANDs to suppress the install step.
#
# We need to NOT blank out UPDATE_COMMAND or we can never change the Git revision we point to.
# The cost of this is that we have to re-configure on every build if we do update.

# sdsl-lite (full build using its cmake config)
ExternalProject_Add(sdsl-lite
  GIT_REPOSITORY "https://github.com/simongog/sdsl-lite.git"
  GIT_TAG "ddb0fbbc33bb183baa616f17eb48e261ac2a3672"
  CMAKE_ARGS -DCMAKE_INSTALL_PREFIX:PATH=${INSTALL_DIR} # TODO ADD static build flag
  UPDATE_COMMAND ""
  INSTALL_COMMAND "")
ExternalProject_Get_property(sdsl-lite INSTALL_DIR)
set(sdsl-lite_INCLUDE "${INSTALL_DIR}/src/sdsl-lite-build/include")
set(sdsl-lite-divsufsort_INCLUDE "${INSTALL_DIR}/src/sdsl-lite-build/external/libdivsufsort/include")
set(sdsl-lite_LIB "${INSTALL_DIR}/src/sdsl-lite-build/lib")
set(sdsl-lite-divsufsort_LIB "${INSTALL_DIR}/src/sdsl-lite-build/external/libdivsufsort/lib")

# DYNAMIC (full build using its cmake config)
ExternalProject_Add(dynamic
  GIT_REPOSITORY "https://github.com/vgteam/DYNAMIC.git"
  GIT_TAG "615d8be5276bcd4c5a3d8e31679b4f8e81b2eefc"
  # we don't actually install dynamic... it's header only
  #CMAKE_ARGS -DCMAKE_INSTALL_PREFIX:PATH=${INSTALL_DIR}
  UPDATE_COMMAND ""
  INSTALL_COMMAND ""
  BUILD_COMMAND ""
  CONFIGURE_COMMAND "")
ExternalProject_Get_property(dynamic INSTALL_DIR)
set(dynamic_INCLUDE "${INSTALL_DIR}/src/dynamic/include")

# In-place Parallel Super Scalar Samplesort (IPS⁴o), header only
ExternalProject_Add(ips4o
  GIT_REPOSITORY "https://github.com/SaschaWitt/ips4o.git"
  GIT_TAG "a34d7d40c0f1279510e35e0dc2c69637b3c5d0b6"
  #GIT_REPOSITORY "https://github.com/ekg/ips4o.git"
  #GIT_TAG "f7eccc5a26928b5c0772922f7b76072414ef1801"
  UPDATE_COMMAND ""
  INSTALL_COMMAND ""
  BUILD_COMMAND ""
  CONFIGURE_COMMAND "")
ExternalProject_Get_property(ips4o SOURCE_DIR)
set(ips4o_INCLUDE "${SOURCE_DIR}")

# atomic queue
ExternalProject_Add(atomicqueue
  GIT_REPOSITORY "https://github.com/max0x7ba/atomic_queue.git"
  GIT_TAG "430f732da0889b090705ad00ce15d4463fe7b536"
  UPDATE_COMMAND ""
  INSTALL_COMMAND ""
  BUILD_COMMAND ""
  CONFIGURE_COMMAND "")
ExternalProject_Get_property(atomicqueue SOURCE_DIR)
set(atomicqueue_INCLUDE "${SOURCE_DIR}")

# paryfor parallel_for
ExternalProject_Add(paryfor
  GIT_REPOSITORY "https://github.com/ekg/paryfor"
  GIT_TAG "509b28a092f732a068e2908bb9e359a8562cd32f"
  UPDATE_COMMAND ""
  INSTALL_COMMAND ""
  BUILD_COMMAND ""
  CONFIGURE_COMMAND "")
ExternalProject_Get_property(paryfor SOURCE_DIR)
set(paryfor_INCLUDE "${SOURCE_DIR}")

# taywee's C++ args library, header only
ExternalProject_Add(tayweeargs
  GIT_REPOSITORY "https://github.com/Taywee/args.git"
  GIT_TAG "3de44ec671db452cc0c4ef86399b108939768abb"
  UPDATE_COMMAND ""
  INSTALL_COMMAND "")
ExternalProject_Get_property(tayweeargs SOURCE_DIR)
set(tayweeargs_INCLUDE "${SOURCE_DIR}")

#set(CMAKE_BUILD_TYPE Release)

# set up our target executable and specify its dependencies and includes
add_executable(mmmulti
  ${CMAKE_SOURCE_DIR}/src/main.cpp
  )
add_dependencies(mmmulti sdsl-lite)
add_dependencies(mmmulti dynamic)
add_dependencies(mmmulti ips4o)
add_dependencies(mmmulti atomicqueue)
add_dependencies(mmmulti paryfor)
add_dependencies(mmmulti tayweeargs)
target_include_directories(mmmulti PUBLIC
  "${CMAKE_SOURCE_DIR}/src"
  "${sdsl-lite_INCLUDE}"
  "${sdsl-lite-divsufsort_INCLUDE}"
  "${dynamic_INCLUDE}"
  "${ips4o_INCLUDE}"
  "${atomicqueue_INCLUDE}"
  "${paryfor_INCLUDE}"
  "${tayweeargs_INCLUDE}")
  
# macOS doesn't want you to link in libatomic this way
if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  target_link_libraries(mmmulti
    "${sdsl-lite_LIB}/libsdsl.a"
    "${sdsl-lite-divsufsort_LIB}/libdivsufsort.a"
    "${sdsl-lite-divsufsort_LIB}/libdivsufsort64.a"
    Threads::Threads
    )
elseif (TRUE)
  target_link_libraries(mmmulti
    "${sdsl-lite_LIB}/libsdsl.a"
    "${sdsl-lite-divsufsort_LIB}/libdivsufsort.a"
    "${sdsl-lite-divsufsort_LIB}/libdivsufsort64.a"
    "-latomic"
    Threads::Threads
    )
endif()


if (APPLE)
elseif (TRUE)
  # this was hard to track down
  # https://stackoverflow.com/questions/35116327/when-g-static-link-pthread-cause-segmentation-fault-why
  set(CMAKE_EXE_LINKER_FLAGS "-static -Wl,--whole-archive -lpthread -Wl,--no-whole-archive")
endif()

=== debian/changelog ===
libmmmulti (0.1-4) unstable; urgency=medium

  * Team upload.
  * cmake-4.patch: new: bump minimum cmake to 3.10. (Closes: #1113174)
  * d/watch: bump to v5 Github template.
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.

 -- Étienne Mollier <emollier@debian.org>  Thu, 02 Oct 2025 21:51:21 +0200

libmmmulti (0.1-3) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.6.2 (routine-update)
  * d/clean: Remove generated bin/ directory (Closes: #1048502)
  * d/salsa-ci.yml: Disable i386 builds, since some build depends are not
    installable (libatomic-queue-dev and libsdsl-dev)

 -- Lance Lin <lq27267@gmail.com>  Thu, 21 Dec 2023 19:41:36 +0700

libmmmulti (0.1-2) unstable; urgency=medium

  * Source-only-upload.

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 29 Oct 2020 19:01:43 +0530

libmmmulti (0.1-1) unstable; urgency=medium

  * Initial release (Closes: #963718)

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 25 Jun 2020 18:14:01 +0200

=== debian/control ===
Source: libmmmulti
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Andreas Tille <tille@debian.org>,
Build-Depends: debhelper-compat (= 13),
               libargs-dev,
               libatomicbitvector-dev,
               libatomic-queue-dev,
               libsdsl-dev,
               libips4o-dev,
               libparyfor-dev,
               cmake
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/ekg/mmmulti
Vcs-Browser: https://salsa.debian.org/med-team/libmmmulti
Vcs-Git: https://salsa.debian.org/med-team/libmmmulti.git

Package: libmmmulti-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: header only library for mmmulti
 Sometimes you have a lot of plain-old data, but you need random access
 to it. These header-only classes combine memory-mapped files with
 high-performance parallel sorting and appropriate indexing strategies
 to support very large (>memory but <disk) multimaps, multisets, and
 interval trees.
 .
 This implements a memory backed multimap intended for use where:
  * your keys are integers, or can be mapped to dense range of integers,
  * the memory mapped file is on fast storage, like an SSD (although
    this is not a requirement),
  * you have arbitrary values of fixed size (e.g. structs, other POD
    types) that can be sorted,
  * you don't need dynamic updates of the table,
  * and you are likely to run out of memory of you use a traditional
    map or hash table,
  * but you can handle approximately 1 bit per record in RAM.
 .
 These may seem to be very specific, but many problems can be mapped into
 a dense integer set. mmmulti::map developed first as a data structure
 to support seqwish, which uses it to generate precise variation graphs
 from pairwise alignments between collections of sequences. As this
 multimap forms a key data processing kernel in the algorithm, it can
 scale to extremely large problem sizes, limited only by available disk
 space. Although performance is much slower than an in-memory structure,
 it is virtually guaranteed to be able to complete the compute.

Package: mmmulti
Section: science
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: memory backed multimap
 This implements a memory backed multimap intended for use where:
  * your keys are integers, or can be mapped to dense range of integers,
  * the memory mapped file is on fast storage, like an SSD (although
    this is not a requirement),
  * you have arbitrary values of fixed size (e.g. structs, other POD
    types) that can be sorted,
  * you don't need dynamic updates of the table,
  * and you are likely to run out of memory of you use a traditional
    map or hash table,
  * but you can handle approximately 1 bit per record in RAM.
 .
 These may seem to be very specific, but many problems can be mapped into
 a dense integer set. mmmulti::map developed first as a data structure
 to support seqwish, which uses it to generate precise variation graphs
 from pairwise alignments between collections of sequences. As this
 multimap forms a key data processing kernel in the algorithm, it can
 scale to extremely large problem sizes, limited only by available disk
 space. Although performance is much slower than an in-memory structure,
 it is virtually guaranteed to be able to complete the compute.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@


#override_dh_auto_configure:
#	dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
Version: 5

Template: Github
Owner: ekg
Project: mmmulti
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%mmmulti-$1.tar.gz%
